# -*- coding: utf-8 -*-

import numpy as np
import matplotlib.pyplot as plt



#\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
#------------ 4 - a)  importation des données ------------------------------



from sklearn import datasets
digits = datasets.load_digits()
n_samples = len(digits.images)
donnees, labels = digits.images.reshape((n_samples, -1)) , digits.target


from sklearn.datasets import fetch_olivetti_faces
olivettiDataSet= fetch_olivetti_faces()
donnees, labels=olivettiDataSet['data'],olivettiDataSet['target']


# i=50
# plt.imshow(donnees[i].reshape((8,8)), cmap="gray")
#\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
#--------------------- 4 - b) Clustering K-Means - Nombre de clusters optimal -----------

from sklearn.cluster import KMeans
import matplotlib.pyplot as plt


#corrigé !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
K=[i for i in range(20,100,20)]
L_variance=[]
for i in range(len(K)):
    KM=KMeans(n_clusters=K[i], random_state=170)
    labels_predits = KM.fit_predict(donnees)
    Variance=KM.inertia_
    L_variance.append(Variance)

fig, ax = plt.subplots()
ax.set_xlabel('Nombre K de centroïdes')
ax.set_ylabel('variance')
ax.plot(K,L_variance)


# #\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
# #------------------------------- 4 - c) Clustering K-Means – Validation du clustering ------

K=40  # à enlever, remplacer 10 par "à compléter******************************************************************
KM=KMeans(n_clusters=K, random_state=170)
labels_predits = KM.fit_predict(donnees)
Variance=KM.inertia_



#corrigé !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
s=0
for i in range(len(labels)):
    if labels[i]==labels_predits[i]:
        s=s+1
taux_d_erreur=(len(labels)-s)/float(len(labels))





#////////////////////////////////////////////////////////////////////////////////////////////////////////////
#--------------------   4 - d)  KNN avec scikit learn  et validation par matrice de confusion    ---------------------------------------------------------

from sklearn import model_selection
(donnees_entrainement, donnees_test, labels_entrainement, labels_test) = model_selection.train_test_split(donnees, labels, test_size=0.3, random_state=12, stratify=labels)


#corrigé !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
from sklearn import neighbors
objetKNN = neighbors.KNeighborsClassifier(n_neighbors=5)
objetKNN.fit(donnees_entrainement, labels_entrainement)

labels_predits = objetKNN.predict(donnees_test)


from sklearn.metrics import confusion_matrix
Matrice_de_confusion = confusion_matrix(labels_test, labels_predits)


# olivetti data set


from sklearn.datasets import fetch_olivetti_faces
olivettiDataSet= fetch_olivetti_faces()
donnees, labels=olivettiDataSet['data'],olivettiDataSet['target']

from sklearn import model_selection
(donnees_entrainement, donnees_test, labels_entrainement, labels_test) = model_selection.train_test_split(donnees, labels, test_size=0.3, random_state=12, stratify=labels)

from sklearn import neighbors
objetKNN = neighbors.KNeighborsClassifier(n_neighbors=5)
objetKNN.fit(donnees_entrainement, labels_entrainement)
labels_predits = objetKNN.predict(donnees_test)

from sklearn.metrics import confusion_matrix
Matrice_de_confusion = confusion_matrix(labels_test, labels_predits)

#////////////////////////////////////////////////////////////////////////////////////////////////////////////
#--------------------   4 - e)  Validation croisée    ---------------------------------------------------------


from sklearn import model_selection
from sklearn import neighbors
L_K = [1, 2, 3, 4, 5, 6, 7, 8, 9]
knnclass_cv = model_selection.GridSearchCV(neighbors.KNeighborsClassifier(),
                                          {'n_neighbors': L_K}, cv=5, scoring='accuracy')
knnclass_cv.fit(donnees, labels)
print("meilleure valeur de k : ", knnclass_cv.best_params_['n_neighbors'])
print("exactitude", knnclass_cv.best_score_)


